define(function(require){
	var $ = require("jquery");
	require("$UI/system/lib/biz");
	var justep = require("$UI/system/lib/justep");
	var PopPicker = require("$UI/system/components/justep/picker/popPicker");
	
	var biz = require("$UI/system/lib/biz");
	require("cordova!cordova-plugin-geolocation");
	require("cordova!cordova-plugin-device");
	require("cordova!nxtpush-cordova-plugin");
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.getAgentList = function(){
		return window.__justep.__portalContext.data.agentList;
	};
	
	function documentBindEventListener(eventType, callback) {
		document.removeEventListener(eventType, callback, false);
		document.addEventListener(eventType, callback, false);
	}
	
	//将  手机厂商manufacturer、手机系统fEquip、设备注册IDreggreid存入用户表中  
	Model.prototype.insert = function(manufacturer, Reggreid, fEquip){
		var params = new biz.Request.ActionParam();
		
		params.setString("fUserID",this.getContext().getCurrentPersonID());
		params.setString("Regeid", Reggreid);
        params.setString("Mobile", manufacturer);
        params.setInteger("fEquip", fEquip);
        
        biz.Request.sendBizRequest({
            dataType : "application/json",
            context : this.getContext(),
            action : "preservationAction",
            parameters : params
		});
	};
	
	Model.prototype.modelLoad = function(event){

		//判断是否IOS
		if( window.device.manufacturer == "Apple" ){
			$(this.getElementByXid("panel1")).css("top","22px");
		}
		if(justep.Browser.isX5App){
			var manufacturer = window.device.manufacturer;//手机厂商
			
			window.plugins.NXTPlugin.init(); //推送服务启动
			
			//判断手机是否是IOS系统,还是android系统
			var Phone = justep.Browser.isX5App;
			var IOS = justep.Browser.isIOS;
			var fEquip = 0;
			
			if(Phone){
				if(IOS){ 
					fEquip=2;
				}else{
					fEquip=1;
				}
			}
			
			//采用极光推送时，获取设备注册ID
			
			var reggreid;//设备注册ID
			var that = this;
			if(manufacturer !="HUAWEI" &&  manufacturer !="Xiaomi"){
				manufacturer = "JIGUANG";		
				//获取Regeid
				window.plugins.NXTPlugin.getRegistrationID(function(id) {
					if(id.length != 0 ){
						reggreid = id;
						
						//将  手机厂商manufacturer、手机系统fEquip、设备注册IDreggreid存入用户表中  
						that.insert(manufacturer, reggreid, fEquip);
					}
				});
				
				//第一次登陆APP时获取Regeid
				documentBindEventListener("jpush.receiveRegistrationId", function(token) {
					reggreid = token.registrationId;
					
					//将  手机厂商manufacturer、手机系统fEquip、设备注册IDreggreid存入用户表中  
					that.insert(manufacturer, reggreid, fEquip);
				});
				//采用华为推送、小米推送时，获取设备注册ID	
			}else{
				documentBindEventListener("jpush.onReceiveHuaWeiToken", function(token) {
					reggreid = token.token;
					
					//将  手机厂商manufacturer、手机系统fEquip、设备注册IDreggreid存入用户表中  
					that.insert(manufacturer, reggreid, fEquip);
					
				});
			}
			
			//获取地址
			this.queryAddr();
		}
	
		//延迟创建不影响显示
	
		var sum = 0;
		var sum1 = 0;

		//任务
		var task =this.comp("taskData");
		task.setFilter("filter1", "(SA_Task.sStatusID = 'tesExecuting' or SA_Task.sStatusID='tesReady') and SA_Task.sEURL is not null and SA_Task.sExecutorPersonID = '"+this.getContext().getCurrentPersonID()+"'");
		task.refreshData();

		sum = task.getTotal();
		//alert(justep.Date.toString(new Date(),"yyyy-MM-dd"))
/*		task.setFilter("filter1", "SA_Task.sStatusID = 'tesExecuting' and SA_Task.sEURL is not null and SA_Task.sCreatorPersonID = '"+this.getContext().getCurrentPersonID()+"'");
		task.refreshData();
		sum1 = task.getTotal();*/

		if(sum == 0 ){
			$(this.getElementByXid("div92")).hide();
		}else{
			$(this.getElementByXid("div92")).show();
		}
		
		if(sum1 == 0 ){
			$(this.getElementByXid("span10")).hide();
		}else{
			$(this.getElementByXid("span10")).show();
		}

		var numData =this.comp("numData");
		numData.newData();
		numData.setValue("sum", sum);//需要我审批
		numData.setValue("sum1", sum1);//我提交的
	};

    //个人中心
	Model.prototype.button5Click = function(event){
		var url = this.getUrl({
			url : '/UI2/portal/mobile/main/person.w',
			param : {
				process : this.getContext().getProcess(),
				activity : this.getContext().getActivity()
			}
		});
		justep.Portal.openWindow(url);
	};
	
	Model.prototype.getUrl = function(options) {
		var url = new justep.URL(require.toUrl(options.url));
		if (options.param) {
			$.each(options.param, function(key, val) {
				var paramJson = {};
				paramJson[key] = val;
				url.setParam(paramJson);
			});
		} else {
			url.setParam({
				process : this.getContext().getProcess()
			});
			url.setParam({
				activity : this.getContext().getActivity()
			});
		}
		return url.toString();
	};

	
	//通讯录
	Model.prototype.button4Click = function(event){
		var url = this.getUrl({
			url : '/UI2/OA/addressBook/process/addressBookSystem/mainActivity.m.w',
			param : {
				process : '/OA/addressBook/process/addressBookSystem/addressBookSystemProcess',
				activity : 'startActivity'
			}
		});
		justep.Portal.openWindow(url);
	};

	//显示个人信息
	Model.prototype.button3Click = function(event){
		//$(this.getElementByXid("div10")).slideToggle();
	};

	//受邀会议
	Model.prototype.image4Click = function(event){
		var url = this.getUrl({
			url : '/UI2/OA/meet/process/meetManage/mainActivity.m.w',
			param : {
				process : '/OA/meet/process/meetManage/meetManageProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};

	//进入会场
	Model.prototype.image21Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/meet/process/meetManage/HuiyiGoto.m.w',
			param : {
				process : '/OA/meet/process/meetManage/meetManageProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};

	//历史会议
	Model.prototype.image13Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/meet/process/meetManage/HuiyiHistory.m.w',
			param : {
				process : '/OA/meet/process/meetManage/meetManageProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};

	//会议请假
	Model.prototype.image3Click = function(event){
           var url = this.getUrl({
			url : '/UI2/OA/meet/process/meetManage/HuiyiShenPiList.m.w',
			param : {
				process : '/OA/meet/process/meetManage/meetManageProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	//所有请假
	Model.prototype.image22Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/meet/process/meetManage/HuiYiQingJiaAll.m.w',
			param : {
				process : '/OA/meet/process/meetManage/meetManageProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};


	
	// 查询地址
	Model.prototype.queryAddr = function() {	
		var self= this;
		var gpsDtd = this.getLocation();               // 获取当前信息
		gpsDtd.done(function(position) {
			self.latitude = position.latitude;         // 纬度
			self.longitude = position.longitude;       // 经度
			justep.Baas.sendRequest({
				"url" : "/PunchMap/map",
				"action" : "queryAddr",
				"async" : false,
				"params" : {
					x : self.latitude,
					y : self.longitude
				},
				"success" : function(data) {
					if (!data) {
						return;
					}
					self.comp("data1").setValue("address", data.address);	 
				}
			});
		});
	};
	// 获取当前位置
	Model.prototype.getLocation = function() {
		var gpsDtd = $.Deferred();
		if (navigator.geolocation) {
			var success = function(data) {
				gpsDtd.resolve({
					coorType : data.coorType,
					address : data.address,
					longitude : data.coords.longitude,
					latitude : data.coords.latitude
				// 文字描述的地址信息
				});
			};
			var fail = function(e) {
				justep.Util.hint("获取地理位置失败，暂时采用默认地址");
				gpsDtd.resolve({
					longitude : 115.9743122643,// 115.633617
					latitude : 28.6845101208//29.063769
				});
			};
            navigator.geolocation.getCurrentPosition(success, fail);
		} else {
			justep.Util.hint("获取地理位置失败，暂时采用默认地址");
			gpsDtd.resolve({
					longitude : 115.9743122643,// 115.633617
					latitude : 28.6845101208//29.063769
			});
		}
		return gpsDtd.promise();
	};
	
	//地方标准
	Model.prototype.a4Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/task/process/task/localAction.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	
	//技术委员会
	Model.prototype.a7Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/task/process/task/techniCalAction.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	
	//标准化监督
	Model.prototype.a5Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/task/process/task/supervisionAction.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	
	//科研项目
	Model.prototype.a8Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/task/process/task/sciProjectAction.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	
	//试点示范
	Model.prototype.a9Click = function(event){
        var url = this.getUrl({
			url : '/UI2/OA/task/process/task/demonstrationAction.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);
	};
	//会议管理展开
	Model.prototype.button1Click = function(event){
		$(this.getElementByXid("formGroup4")).show();
		$(this.getElementByXid("button2")).show();
		$(this.getElementByXid("button20")).hide();
	};
	//会议管理收起
	Model.prototype.button2Click = function(event){
		$(this.getElementByXid("formGroup4")).hide();
		$(this.getElementByXid("button2")).hide();
		$(this.getElementByXid("button20")).show();
	};
	
	


	//我申请的
	Model.prototype.image122Click = function(event){
		 var url = this.getUrl({
			url : '/UI2/OA/task/process/task/wosengqingTask.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);		
	};

	
	//我审批的
	Model.prototype.image11Click = function(event){
		 var url = this.getUrl({
			url : '/UI2/OA/task/process/task/wspTask.m.w',
			param : {
				process : '/OA/task/process/task/taskProcess',
				activity : 'mainActivity'
			}
		});
		justep.Portal.openWindow(url);		
	};
	
	

	
	
	Model.prototype.list2Click = function(event){
	var task =this.comp("taskData");
	var url=task.getValue("sEURL");
	var task1=task.getValue("SA_Task");
	var process=task.getValue("sProcess");
	var activity=task.getValue("sActivity");
	var sData1=task.getValue("sData1");
	var executor=task.getValue("sExecutorFID");
	var url1 ="$UI/"+url+"?task="+task1+"&_pagePattern=write&process="+process+"&activity="+activity+"&sData1="+sData1+"&executor="+executor;
	//alert(url1);
	justep.Portal.openWindow(url1);
	};
	
	

	Model.prototype.modelActive = function(event){
		this.comp("taskData").refreshData();
	};
	
	Model.prototype.button6Click = function(event){
	$(this.getElementByXid("div122")).show();	
	};
	
	Model.prototype.quxiaoClick = function(event){
	$(this.getElementByXid("div122")).hide();	
	};
	
	Model.prototype.input1Blur = function(event){
	var data =this.comp("taskData");
	var data1=this.comp("data1");
	if(data1.getValue("select")==null || data1.getValue("select")==""||data1.getValue("select")==undefined){
	data.setFilter("filter2", "1=1");
	data.refreshData();	
	}else{
	data.setFilter("filter2", "SA_Task.sName like '%"+data1.getValue("select")+"%' or SA_Task.sTypeName like '%"+data1.getValue("select")+"%' or SA_Task.sCreatorPersonName like '%"+data1.getValue("select")+"%'");
	data.refreshData();	
	}
	$(this.getElementByXid("div122")).hide();	
	};
	
	Model.prototype.button7Click = function(event){
	$(this.getElementByXid("div32")).show();	
	};
	
	Model.prototype.quedingClick = function(event){
		var filter ="1=2";
		 var data =this.comp("taskData");
	if( $(this.getElementByXid("a14")).is('.on')){
		filter+=" or SA_Task.sTypeName='标准审定' or SA_Task.sTypeName='标准立项' or SA_Task.sTypeName='报批' or SA_Task.sTypeName='备案' or SA_Task.sTypeName='复审'";
	}
	if($(this.getElementByXid("a15")).is('.on')){
	filter+=" or SA_Task.sTypeName='技术管理委员会'";
	}
	if($(this.getElementByXid("a16")).is('.on')){
	filter+=" or SA_Task.sTypeName='标准化监督申请'";
	}
	if($(this.getElementByXid("a1")).is('.on')){
	filter+=" or SA_Task.sTypeName='国家试点示范' or SA_Task.sTypeName='国家试点示范验收' or SA_Task.sTypeName='省级试点示范' or SA_Task.sTypeName='省级试点示范验收'";
	}
	
	if($(this.getElementByXid("a2")).is('.on')){
	filter+=" or SA_Task.sTypeName='科研项目申报' or SA_Task.sTypeName='重新申报' or SA_Task.sTypeName='重新验收' or SA_Task.sTypeName='科研验收' or SA_Task.sTypeName='科研项目征集指南'";
	}
	//alert(filter)
	data.setValue("filter3", "1=2");
	data.refreshData();	

	$(this.getElementByXid("div32")).hide();		
	};
	
	
	Model.prototype.a14Click = function(event){
		if( $(this.getElementByXid("a14")).is('.on')){
			$(this.getElementByXid("a14")).removeClass("on");
		}else{
			$(this.getElementByXid("a14")).addClass("on");
		}
	};
	
	Model.prototype.a15Click = function(event){
		if( $(this.getElementByXid("a15")).is('.on')){
			$(this.getElementByXid("a15")).removeClass("on");
		}else{
			$(this.getElementByXid("a15")).addClass("on");
		}
	};
	
	Model.prototype.a16Click = function(event){
		if( $(this.getElementByXid("a16")).is('.on')){
			$(this.getElementByXid("a16")).removeClass("on");
		}else{
			$(this.getElementByXid("a16")).addClass("on");
		}
	};
	
	Model.prototype.a1Click = function(event){
		if( $(this.getElementByXid("a1")).is('.on')){
			$(this.getElementByXid("a1")).removeClass("on");
		}else{
			$(this.getElementByXid("a1")).addClass("on");
		}
	};
	
	Model.prototype.a2Click = function(event){
		if( $(this.getElementByXid("a2")).is('.on')){
			$(this.getElementByXid("a2")).removeClass("on");
		}else{
			$(this.getElementByXid("a2")).addClass("on");
		}
	};
	Model.prototype.toString  = function(date){
		var curTime = "";
		if( date != undefined){
			if( (justep.Date.toString(new Date(date),'yyyy-MM-dd hh:mm:ss'))<(justep.Date.toString(new Date(),"yyyy-MM-dd 00:00:00"))){
			curTime = justep.Date.toString(new Date(date),'yyyy.MM.dd');
			}else{
			curTime = justep.Date.toString(new Date(date),'hh:mm:ss');
			}

		}
		return curTime;
	};

	return Model;
});